 _CLKMODE = XTAL1 + PLL16X ' The clock frequency is equal to 80MHz = 5MHz * 16X PLL.
'  _XINFREQ = 5_000_000 '
 _clkfreq = 80_000000
  _STACK = 640 ' Reserve some space for the stack and free.
'Propeller 1-2-3 
  _I2C_CLOCK_PIN = 0 ' I2C bus pins. Must use 4.7K pullups to 3.3v
  _I2C_DATA_PIN = 2
  _CAM_VSYNC_PIN =4
  _CAM_HREF_PIN =6
  _CAM_PCLK_PIN = 8
  _CAM_XCLK_PIN = 10
'de2-115 addon  settings
{
  _CAM_XCLK_PIN = 11' Camera signaling pins.
  _CAM_PCLK_PIN = 9' '
  _CAM_VSYNC_PIN =5
  _CAM_HREF_PIN =7
  _I2C_CLOCK_PIN = 1 ' I2C bus pins. Must use 4.7K pullups to 3.3v
  _I2C_DATA_PIN = 3 '
}

  'PAB pin settings
{
  _CAM_XCLK_PIN = 10 ' Camera signaling pins.
  _CAM_PCLK_PIN = 11 '
  _CAM_VSYNC_PIN = 13 '
  _CAM_HREF_PIN = 12 '
  _I2C_CLOCK_PIN = 15 ' I2C bus pins. Must use 4.7K pullups to 3.3v
  _I2C_DATA_PIN = 14 '
                     }                                     
  SerRxPin      =31            ' Serial interface via Prop Clip, IN from user
  SerTxPin      = 30              '                                 OUT to user

Var
   long CamXVCLKFreq,framep1clocks,cps,reps,iterations,xclkdiff,match,_SCCB_CAMERA_WRITE_ADDRESS,_SCCB_CAMERA_READ_ADDRESS,Camera_id
   long sccb_temp,ii,tempvar,width,height,pinstate,polarity,mydata,time,Counter1,Counter2,reg,testval,framerate,pixelclocks,pixelsperline,linesperframe,i,data16
   long VsyncH,VsyncL
   long sig
   long start
   byte LSBdata,MSBdata
   byte databuffer[10000]

OBJ

    freq          : "Synth"                               ' Frequency synthesizer (included w/ Parallax Propeller Tool)
    ser           :"FullDuplexSerial"
PUB I2C_test |cmd
  cognew(@entry, @start)
  i:=0
  reps:=50  'number of times frames per second,lines per frame,pixels per line are measured
  iterations:=1 'number of iterations through measurement routine...
  xclkdiff:=0 'change frequency of external clock per iteration
  camera_id:=0
  CamXVCLKFreq:=20_000_000 'initial xclk frequency
  freq.Synth("A",  _CAM_XCLK_PIN, CamXVCLKFreq)   ' Configure Counter A to synthesize input clock (XVCLK) for OVM7690
  ser.start(SerRxPin,SerTxPin,0,115200)
  waitcnt(clkfreq + cnt)
  ser.rxflush
  waitcnt(clkfreq + cnt) 'give the camera a chance to wake up
  ii:=1
  repeat iterations
   ' i:=GetID

    freq.Synth("A",  _CAM_XCLK_PIN, CamXVCLKFreq)   ' Configure Counter A to synthesize input clock (XVCLK) for OVM7690
    start:=0
    ser.tx(0)
    ser.str(string("Analysis settings: "))
    ser.str(string("XCLK="))
    ser.dec(CamXVCLKFreq/1000000)
    ser.str(string("."))
    tempvar:=CamXVCLKFreq//10000
    if tempvar<10
      ser.str(string("0"))
    ser.dec(tempvar)
    ser.str(string("MHz"))
    ser.str(string("   XCLKdiff="))
    ser.dec(xclkdiff)
    ser.str(string("   Iterations="))
    ser.dec(iterations)
    ser.str(string("   Reps="))
    ser.dec(reps)
    ser.tx(13)
    ser.str(string(13,"Iteration Number="))
    ser.dec(ii)
    ser.tx(13)
    waitcnt(clkfreq/2 + cnt)
    i:=DefineSignal
    CamXVCLKFreq:=CamXVCLKFreq + xclkdiff
    if camera_ID == $5642
      do_5642

  ser.str(string(13,"all done"))
  repeat

   repeat until (cmd >1)
     cmd := ser.Rx               ' Wait here to receive a byte
   ' ser.str(string("command="))
    'ser.tx(cmd)
    'ser.tx(13)
     case cmd
      "L", "l": GetRegisters                'Get Register Settings
      "D","d": DefineSignal
      "T","t": transmit
      "C", "c": capture
     cmd:=0
Pri GetVSync
  ctrb := %01000<< 26  + _CAM_VSYNC_PIN '12 
  ser.str(string(13,"Vsync(+)= "))
  Polarity:=GetSigAv(3) 
  Ser.dec(Polarity)                                     '
  ser.str(string("  ...very rough. P1 clocks during 1 second period") )                                     '
  ctrb := %01100<< 26  + _CAM_VSYNC_PIN '12 
  ser.str(string(13,"Vsync(-)= "))
  Polarity:=GetSigAv(3) 
  Ser.dec(Polarity)                   
  ser.str(string("  ...very rough. P1 clocks during 1 second period") ) 
Pri GetHREF
  ctrb := %01000<< 26  + _CAM_HREF_PIN
  ser.str(string(13,"Href(+)= "))
  Polarity:=GetSigAv(3) 
  
  ser.str(string("  ...very rough. P1 clocks during 1 second period=") ) 
  Ser.dec(Polarity) 
  ctrb := %01100<< 26  + _CAM_HREF_PIN
  ser.str(string(13,"Href(-)= "))
  Polarity:=GetSigAv(3) 
  ser.str(string("  ...very rough. P1 clocks during 1 second period=") ) 
  Ser.dec(Polarity)   
 ' pinstate:=1<<_CAM_HREF_PIN  
Pri Do_5642
  ser.str(string("gothere2"))
  SCCBWriteRegister($3008,$80)  'software reset
  ser.str(string(13,"Software Reset",13))
 ' DefineSignal



'  SCCBWriteRegister($ffff,$ff) 
 
 ' waitcnt(clkfreq + cnt)
'  SCCBWriteRegister($3008,$00) 
' SCCBWriteRegister($ffff,$ff) 
  'DefineSignal

  waitcnt(clkfreq/2 + cnt)
 ' SCCBWriteRegister($3008,$00)  'software reset
 ' Set_Registers
  i:=0
  
  GetID
  ser.str(string(13,"Set Registers"))
  i:=Set_Registers
  waitcnt(clkfreq + cnt)
  ser.str(string(13,"Set Polarity"))
  
  waitcnt(clkfreq + cnt)
  SCCBWriteRegister($4740, %00100000)
 
 ' DefineSignal

 ' DefineSignal
  

'  DefineSignal
  
 ' SCCBWriteRegister($3009,$10000001) 'pll predivider step
                                         '
 ' SCCBWriteRegister($3012 ,%00000011) 'pll divider
 ' ser.str(string(13,"pll divider"))
  'waitcnt(clkfreq*2 + cnt)
 ' SCCBWriteRegister($3011 ,%10000000)  'pllbypass
'  ser.str(string(13," bypass pll"))
  'waitcnt(clkfreq*10 + cnt)
 ' SCCBWriteRegister($3010 ,%10000001)  'pll divider01 $70=%01110000 mod
'  SCCBWriteRegister($3017 ,%11111110) 
  'SCCBWriteRegister($3018 ,%11111100) 
  ser.str(string(13,"output formatsetting = "))
  SCCBWriteRegister($4300 ,$30)  'YUYV $30set in doVG y8=%0001zzzz
  SCCBReadRegister($4300,@tempvar)
  ser.str(string(13,"YUY= $30   y8=%0001zzzz=$10"))
  ser.str(string(13,"register $4300 setting = "))
  ser.hex(tempvar,4)
  waitcnt(clkfreq*3 + cnt)
  DefineSignal
  get_resolution
 ' ser.str(string(13,"Set resolution"))
  
 ' set_resolution(256,256)
  
  waitcnt(clkfreq*3 + cnt)
 
  
  set_resolution(640,480)
  
  waitcnt(clkfreq*3+cnt)
 ' SCCBwriteRegister($5001,0)
  
  
 
  ser.str(string(13,"Get resolution"))
  get_resolution
  DefineSignal
  SCCBReadRegister($5001,@tempvar)
  ser.str(string(13,"Register 5001="))
  ser.bin(tempvar,8)
 ' SCCBwriteRegister($5001,%01111111)
  SCCBReadRegister($5002,@tempvar)
  ser.str(string(13,"Register 5002="))
  ser.bin(tempvar,8)
  'SCCBwriteRegister($5002,%11111000)
  ser.str(string("waiting",13))
  waitcnt(clkfreq*5 + cnt)
  ser.str(string("setting uv"))
  
  'uv
  '	SCCBWRITEREGISTER($5500 ,$10)
	SCCBWRITEREGISTER($5502 ,$00)
	SCCBWRITEREGISTER($5503 ,$06)
	SCCBWRITEREGISTER($5504 ,$00)
	SCCBWRITEREGISTER($5505 ,$7f)

 ' SCCBWriteRegister($3008,$80)  'software reset
'  Set_Registers
PRI GetID
  sccb_temp:=0
  match:=false
  _SCCB_CAMERA_WRITE_ADDRESS:=$42
  
  _SCCB_CAMERA_READ_ADDRESS:=$43  '7670
  
  SCCBReadRegister($0a,@mydata)
  ii++
  if mydata==$76
    match:=true
    ser.str(string(13,"Manufacturer="))
    SCCBReadRegister($1C,@mydata)
    ser.hex(mydata,2)
    SCCBReadRegister($1D,@mydata)
    ser.hex(mydata,2)
    ser.str(string(13,"Camera*="))
    SCCBReadRegister($0A,@mydata)
    ser.hex(mydata,2)
    Camera_ID:=mydata<<8
    SCCBReadRegister($0B,@mydata)
    ser.hex(mydata,2)    
    Camera_ID:=Camera_id+mydata
    ser.str(string(13,"*many cameras in the 76xx family return the same id"))
    sccb_temp:=$42
    return
  if match ==false
      _SCCB_CAMERA_WRITE_ADDRESS:=$60 'ov2640,
      _SCCB_CAMERA_READ_ADDRESS:=$61
      SCCBReadRegister($0A,@mydata)
      if (mydata ==$26) | (mydata==$96)
        match:=true
        SCCBReadRegister($1C,@mydata)
        ser.hex(mydata,2)
        SCCBReadRegister($1D,@mydata)
        ser.hex(mydata,2)
        ser.str(string(13,"Camera = "))
        SCCBReadRegister($0A,@mydata)
        ser.hex(mydata,2)
        Camera_ID:=mydata<<8
        SCCBReadRegister($0B,@mydata)
        ser.hex(mydata,2) 
        Camera_ID:=Camera_id+mydata
        sccb_temp:=$60
 ' _SCCB_CAMERA_WRITE_ADDRESS:=sccb_temp
 ' _SCCB_CAMERA_READ_ADDRESS:=sccb_temp+1
  if match==false
            _SCCB_CAMERA_WRITE_ADDRESS:=$78  'OV3640 , OV5640
            _SCCB_CAMERA_READ_ADDRESS:=$79
          
            SCCBReadRegister($300A,@mydata)
            if (mydata ==$56) | (mydata==$36)
     
              match:=true
              ser.str(string(13,"Camera ="))
              'ser.hex(mydata,2)
              
              camera_id:=mydata<<8
              SCCBReadRegister($300B,@mydata)
             ' ser.hex(mydata,2)
              
              camera_id:=camera_id+mydata
              ser.hex(camera_id,4)
              ser.tx(13)
              
  if match == false
    ser.str(string("Cannot get Camera ID... This is bad."))  
    
    ser.str(string(13,"Are you testing a supported camera?"))   
    ser.str(string(13,"Did you insert it into the header correctly?"))
    ser.str(string(13,"Does the camera have power?")) 
    waitcnt(clkfreq*3 + cnt)          
    return         
PRI GetSigAv(seconds)
    time:=cnt
    phsb := 0
    waitcnt(Time += clkfreq*seconds)                            ' 1 Second Wait
    Counter1 := phsb                                   ' Get Counter A Value
                               ' Get Counter B Value
                                              ' Reset Counter A
                                          ' Reset Counter B

    Counter1:=Counter1/seconds
    return counter1
Pri Capture
    start:=1
Pri get_resolution 
  SCCBReadRegister($3808,@tempvar)
  width:=tempvar<<8
  SCCBReadRegister($3809,@tempvar)
  width:=width+tempvar
  ser.str(string(13,"image x,y = ("))
  ser.dec(width)
  SCCBReadRegister($380A,@tempvar)
  height:=tempvar<<8
  SCCBReadRegister($380B,@tempvar)
  height:=height+tempvar
  ser.str(string(","))
  ser.dec(height)
  ser.str(string(")",13))
  
Pri set_resolution(x,y) |xres,yres
  ser.str(string(13,"set resolution = ("))
  ser.dec(x)
  ser.str(string(","))
  ser.dec(y)
  ser.str(string(")",13))
  xres:=x>>8
  SCCBWriteRegister($3808,xres)
  xres:=x & 255
	SCCBWriteRegister($3809,xres)
  yres:=y>>8
	SCCBWriteRegister($380a,yres)
  yres:=y & 255

	SCCBWriteRegister($380b,yres)
PRI GetRegisters
  reg := $3000
  ser.str(string(13,"Register            Hex   Binary",13))
  repeat until (reg>$4000)


    SCCBReadRegister(reg,@mydata)
    if (mydata>0)
      ser.str(string(" $"))
      ser.hex(reg,4)
      ser.str(string(" = "))
      ser.dec(reg)
      ser.str(string("       "))
      ser.hex(mydata,2)
      ser.str(string("   "))
      ser.bin(mydata,8)
      ser.str(string("   ",13))

    reg++
    waitcnt(clkfreq/100 + cnt)
  ser.rxflush
PRI SCCBWriteRegister(register, data) ' Writes a camera register.

' Notes:
'
' Register - The register number to write.
' Data - The value to write.
'
' Returns true on success and false on failure.

  I2CStart
  result := I2CWrite(_SCCB_CAMERA_WRITE_ADDRESS)
  result and= I2CWrite16(register)
  result and= I2CWrite(data)
  I2CStop

PRI SCCBReadRegister(register, longDataAddress) ' Reads a camera register.

' Notes:
'
' Register - The register number to read.
' LongDataAddress - The address of the value to store data to.
'
' Returns true on success and false on failure.

  I2CStart
  result := I2CWrite(_SCCB_CAMERA_WRITE_ADDRESS)
  tempvar:=register>>8
  if tempvar > 0
     result and= I2CWrite16(register)
  if tempvar ==0
     result and= I2CWrite(register)
  I2CStop
  if(result)

    I2CStart
    result := I2CWrite(_SCCB_CAMERA_READ_ADDRESS)
    long[longDataAddress] := I2CRead(0)
    I2CStop
PRI I2CWrite16(data) ' Write out data.

' Notes:
'
' Data - The 8 bit packet to transmit.
'
' Returns true if the receiving device ACK'ed and false if not.
  MSBdata:=data>>8
  LSBdata:=data
  data:=MSBdata
  data := ((!data) >< 8)

  repeat  8' Write out all 8 data bits. Leave with clock low.

    dira[_I2C_DATA_PIN] := data
    dira[_I2C_CLOCK_PIN] := 0
    dira[_I2C_CLOCK_PIN] := 1
    data >>= 1

  ' Leave with clock low and data low.

  dira[_I2C_DATA_PIN] := 0
  dira[_I2C_CLOCK_PIN] := 0
  result := not(ina[_I2C_DATA_PIN])
  dira[_I2C_CLOCK_PIN] := 1
  dira[_I2C_DATA_PIN] := 1





  data:=LSBdata
  data := ((!data) >< 8)

  repeat 8 ' Write out all 8 data bits. Leave with clock low.

    dira[_I2C_DATA_PIN] := data
    dira[_I2C_CLOCK_PIN] := 0
    dira[_I2C_CLOCK_PIN] := 1
    data >>= 1

  ' Leave with clock low and data low.

  dira[_I2C_DATA_PIN] := 0
  dira[_I2C_CLOCK_PIN] := 0
  result := not(ina[_I2C_DATA_PIN])
  dira[_I2C_CLOCK_PIN] := 1
 ' dira[_I2C_DATA_PIN] := 1




PRI I2CWrite(data) ' Write out data.

' Notes:
'
' Data - The 8 bit packet to transmit.
'
' Returns true if the receiving device ACK'ed and false if not.

  data := ((!data) >< 8)

  repeat 8 ' Write out all 8 data bits. Leave with clock low.

    dira[_I2C_DATA_PIN] := data
    dira[_I2C_CLOCK_PIN] := 0
    dira[_I2C_CLOCK_PIN] := 1
    data >>= 1

  ' Leave with clock low and data low.

  dira[_I2C_DATA_PIN] := 0
  dira[_I2C_CLOCK_PIN] := 0
  result := not(ina[_I2C_DATA_PIN])
  dira[_I2C_CLOCK_PIN] := 1
  dira[_I2C_DATA_PIN] := 1

PRI I2CRead(aknowledge) ' Read in data.

' Notes:
'
' Aknowledge - True to send the transmitting device an ACK and false to not send a NCK.
'
' Returns the received 8 bit packet.

  dira[_I2C_DATA_PIN] := 0
{  if camera_id ==1110
    repeat 8 ' Read in all 8 data bits. Leave with clock low.

      result <<= 1
      dira[_I2C_CLOCK_PIN] := 0
      result |= ina[_I2C_DATA_PIN]
      dira[_I2C_CLOCK_PIN] := 1
    dira[_I2C_DATA_PIN] :=1' (not(not(aknowledge)))
    outa[_I2C_DATA_PIN]:=1
    dira[_I2C_CLOCK_PIN] := 0
                         
                                                    }                              dira[_I2C_CLOCK_PIN] :=1
  repeat 8
      result <<= 1
      dira[_I2C_CLOCK_PIN] := 0
      result |= ina[_I2C_DATA_PIN]
      dira[_I2C_CLOCK_PIN] := 1
  ' Leave with the clock low and the data low.
  
  dira[_I2C_DATA_PIN] := (not(not(aknowledge)))
  dira[_I2C_CLOCK_PIN] := 0
  dira[_I2C_CLOCK_PIN] := 1
  dira[_I2C_DATA_PIN] := 1

PRI I2CStart ' Cause the I2C start condition.

  outa[_I2C_DATA_PIN] := 0
  dira[_I2C_DATA_PIN] := 1

  outa[_I2C_CLOCK_PIN] := 0
  dira[_I2C_CLOCK_PIN] := 1

PRI I2CStop ' Cause the I2C stop condition.

  dira[_I2C_CLOCK_PIN] := 0
  dira[_I2C_DATA_PIN] := 0
Pri Set_Registers
'vga preview


      ' dosvGApreview
       'doSVGApreview
        doQVGA
       
        dovGApreview               'frex
       ' GetID
                'doNightMode
      '  SCCBWriteRegister($3017 ,%00010000)'pixel clock out
        'SCCBWriteRegister($3503 ,$01)
Pub doQVGA
'qvga
  ser.str(string(13,"doQVGA"))
  
  SCCBWriteRegister($3103,$93)
	SCCBWriteRegister($3008,$82)
	SCCBWriteRegister($3008,$02)
  GetID 
	SCCBWriteRegister($3017,$7f)
  GetID
	SCCBWriteRegister($3018,$00)
  GetID


	SCCBWriteRegister($3810,$c2)
  
	SCCBWriteRegister($3615,$f0)
	SCCBWriteRegister($3000,$00)
	SCCBWriteRegister($3001,$00)
	SCCBWriteRegister($3002,$00)
	SCCBWriteRegister($3003,$00)
	SCCBWriteRegister($3000,$f8)
  

	SCCBWriteRegister($3001,$48)
	SCCBWriteRegister($3002,$5c)
	SCCBWriteRegister($3003,$02)
	SCCBWriteRegister($3004,$07)
	SCCBWriteRegister($3005,$ff)
	SCCBWriteRegister($3006,$ff)
	SCCBWriteRegister($3007,$07)
	SCCBWriteRegister($3011,$08)
	SCCBWriteRegister($3010,$10)
	SCCBWriteRegister($460c,$22)
	SCCBWriteRegister($3815,$04)
	SCCBWriteRegister($370d,$06)
	SCCBWriteRegister($370c,$a0)
	SCCBWriteRegister($3602,$fc)
	SCCBWriteRegister($3612,$ff)
	SCCBWriteRegister($3634,$c0)
	SCCBWriteRegister($3613,$00)
	SCCBWriteRegister($3605,$7c)
	SCCBWriteRegister($3621,$09)
	SCCBWriteRegister($3622,$00)
	SCCBWriteRegister($3604,$40)
	SCCBWriteRegister($3603,$a7)
	SCCBWriteRegister($3603,$27)
	SCCBWriteRegister($4000,$21)
	SCCBWriteRegister($401d,$02)
	SCCBWriteRegister($3600,$54)
	SCCBWriteRegister($3605,$04)
	SCCBWriteRegister($3606,$3f)
	SCCBWriteRegister($3c01,$80)
	SCCBWriteRegister($5000,$4f)
	SCCBWriteRegister($5020,$04)
	SCCBWriteRegister($5181,$79)
	SCCBWriteRegister($5182,$00)
	SCCBWriteRegister($5185,$22)
	SCCBWriteRegister($5197,$01)
	SCCBWriteRegister($5001,$ff)
	SCCBWriteRegister($5500,$0a)
	SCCBWriteRegister($5504,$00)
	SCCBWriteRegister($5505,$7f)
	SCCBWriteRegister($5080,$08)
	SCCBWriteRegister($300e,$18)
	SCCBWriteRegister($4610,$00)
	SCCBWriteRegister($471d,$05)
	'SCCBWriteRegister($4708,$06)dvp
	SCCBWriteRegister($3710,$10)
	SCCBWriteRegister($3632,$41)
	SCCBWriteRegister($3702,$40)
	SCCBWriteRegister($3620,$37)
	SCCBWriteRegister($3631,$01)
	SCCBWriteRegister($3808,$02)
	SCCBWriteRegister($3809,$80)
	SCCBWriteRegister($380a,$01)
	SCCBWriteRegister($380b,$e0)
	SCCBWriteRegister($380e,$07)
	SCCBWriteRegister($380f,$d0)
	SCCBWriteRegister($501f,$00)
	SCCBWriteRegister($5000,$4f)
	SCCBWriteRegister($4300,$30)
	SCCBWriteRegister($3503,$07)
	SCCBWriteRegister($3501,$73)
	SCCBWriteRegister($3502,$80)
	SCCBWriteRegister($350b,$00)
	SCCBWriteRegister($3503,$07)
	SCCBWriteRegister($3824,$11)
	SCCBWriteRegister($3501,$1e)
	SCCBWriteRegister($3502,$80)
	SCCBWriteRegister($350b,$7f)
	SCCBWriteRegister($380c,$0c)
	SCCBWriteRegister($380d,$80)
	SCCBWriteRegister($380e,$03)
	SCCBWriteRegister($380f,$e8)
	SCCBWriteRegister($3a0d,$04)
	SCCBWriteRegister($3a0e,$03)
	SCCBWriteRegister($3818,$c1)
	SCCBWriteRegister($3705,$db)
	SCCBWriteRegister($370a,$81)
	SCCBWriteRegister($3801,$80)
	SCCBWriteRegister($3621,$c7)
	SCCBWriteRegister($3801,$50)
	SCCBWriteRegister($3803,$08)
	SCCBWriteRegister($3827,$08)
	SCCBWriteRegister($3810,$c0)
	SCCBWriteRegister($3804,$05)
	SCCBWriteRegister($3805,$00)
	SCCBWriteRegister($5682,$05)
	SCCBWriteRegister($5683,$00)
	SCCBWriteRegister($3806,$03)
	SCCBWriteRegister($3807,$c0)
	SCCBWriteRegister($5686,$03)
	SCCBWriteRegister($5687,$c0)
	SCCBWriteRegister($3a00,$78)
	SCCBWriteRegister($3a1a,$04)
	SCCBWriteRegister($3a13,$30)
	SCCBWriteRegister($3a18,$00)
	SCCBWriteRegister($3a19,$7c)
	SCCBWriteRegister($3a08,$12)
	SCCBWriteRegister($3a09,$c0)
	SCCBWriteRegister($3a0a,$0f)
	SCCBWriteRegister($3a0b,$a0)
	SCCBWriteRegister($3004,$ff)
	SCCBWriteRegister($350c,$07)
	SCCBWriteRegister($350d,$d0)
	SCCBWriteRegister($3500,$00)
	SCCBWriteRegister($3501,$00)
	SCCBWriteRegister($3502,$00)
	SCCBWriteRegister($350a,$00)
	SCCBWriteRegister($350b,$00)
	SCCBWriteRegister($3503,$00)
	SCCBWriteRegister($528a,$02)
	SCCBWriteRegister($528b,$04)
	SCCBWriteRegister($528c,$08)
	SCCBWriteRegister($528d,$08)
	SCCBWriteRegister($528e,$08)
	SCCBWriteRegister($528f,$10)
	SCCBWriteRegister($5290,$10)
	SCCBWriteRegister($5292,$00)
	SCCBWriteRegister($5293,$02)
	SCCBWriteRegister($5294,$00)
	SCCBWriteRegister($5295,$02)
	SCCBWriteRegister($5296,$00)
	SCCBWriteRegister($5297,$02)
	SCCBWriteRegister($5298,$00)
	SCCBWriteRegister($5299,$02)
	SCCBWriteRegister($529a,$00)
	SCCBWriteRegister($529b,$02)
	SCCBWriteRegister($529c,$00)
	SCCBWriteRegister($529d,$02)
	SCCBWriteRegister($529e,$00)
	SCCBWriteRegister($529f,$02)
	SCCBWriteRegister($3a0f,$3c)
	SCCBWriteRegister($3a10,$30)
	SCCBWriteRegister($3a1b,$3c)
	SCCBWriteRegister($3a1e,$30)
	SCCBWriteRegister($3a11,$70)
	SCCBWriteRegister($3a1f,$10)
	SCCBWriteRegister($3030,$0b)
	SCCBWriteRegister($3a02,$00)
	SCCBWriteRegister($3a03,$7d)
	SCCBWriteRegister($3a04,$00)
	SCCBWriteRegister($3a14,$00)
	SCCBWriteRegister($3a15,$7d)
	SCCBWriteRegister($3a16,$00)
	SCCBWriteRegister($3a00,$7c)
	SCCBWriteRegister($3a08,$09)
	SCCBWriteRegister($3a09,$60)
	SCCBWriteRegister($3a0a,$07)
	SCCBWriteRegister($3a0b,$d0)
	SCCBWriteRegister($3a0d,$08)
	SCCBWriteRegister($3a0e,$06)
	SCCBWriteRegister($5193,$70)
	SCCBWriteRegister($3620,$57)
	SCCBWriteRegister($3703,$98)
	SCCBWriteRegister($3704,$1c)
	SCCBWriteRegister($589b,$04)
	SCCBWriteRegister($589a,$c5)
	SCCBWriteRegister($528a,$00)
	SCCBWriteRegister($528b,$02)
	SCCBWriteRegister($528c,$08)
	SCCBWriteRegister($528d,$10)
	SCCBWriteRegister($528e,$20)
	SCCBWriteRegister($528f,$28)
	SCCBWriteRegister($5290,$30)
	SCCBWriteRegister($5292,$00)
	SCCBWriteRegister($5293,$00)
	SCCBWriteRegister($5294,$00)
	SCCBWriteRegister($5295,$02)
	SCCBWriteRegister($5296,$00)
	SCCBWriteRegister($5297,$08)
	SCCBWriteRegister($5298,$00)
	SCCBWriteRegister($5299,$10)
	SCCBWriteRegister($529a,$00)
	SCCBWriteRegister($529b,$20)
	SCCBWriteRegister($529c,$00)
	SCCBWriteRegister($529d,$28)
	SCCBWriteRegister($529e,$00)
	SCCBWriteRegister($529f,$30)
	SCCBWriteRegister($5282,$00)
	SCCBWriteRegister($5300,$00)
	SCCBWriteRegister($5301,$20)
	SCCBWriteRegister($5302,$00)
	SCCBWriteRegister($5303,$7c)
	SCCBWriteRegister($530c,$00)
	SCCBWriteRegister($530d,$0c)
	SCCBWriteRegister($530e,$20)
	SCCBWriteRegister($530f,$80)
	SCCBWriteRegister($5310,$20)
	SCCBWriteRegister($5311,$80)
	SCCBWriteRegister($5308,$20)
	SCCBWriteRegister($5309,$40)
	SCCBWriteRegister($5304,$00)
	SCCBWriteRegister($5305,$30)
	SCCBWriteRegister($5306,$00)
	SCCBWriteRegister($5307,$80)
	SCCBWriteRegister($5314,$08)
	SCCBWriteRegister($5315,$20)
	SCCBWriteRegister($5319,$30)
	SCCBWriteRegister($5316,$10)
	SCCBWriteRegister($5317,$08)
	SCCBWriteRegister($5318,$02)
	SCCBWriteRegister($5380,$01)
	SCCBWriteRegister($5381,$00)
	SCCBWriteRegister($5382,$00)
	SCCBWriteRegister($5383,$4e)
	SCCBWriteRegister($5384,$00)
	SCCBWriteRegister($5385,$0f)
	SCCBWriteRegister($5386,$00)
	SCCBWriteRegister($5387,$00)
	SCCBWriteRegister($5388,$01)
	SCCBWriteRegister($5389,$15)
	SCCBWriteRegister($538a,$00)
	SCCBWriteRegister($538b,$31)
	SCCBWriteRegister($538c,$00)
	SCCBWriteRegister($538d,$00)
	SCCBWriteRegister($538e,$00)
	SCCBWriteRegister($538f,$0f)
	SCCBWriteRegister($5390,$00)
	SCCBWriteRegister($5391,$ab)
	SCCBWriteRegister($5392,$00)
	SCCBWriteRegister($5393,$a2)
	SCCBWriteRegister($5394,$08)
	SCCBWriteRegister($5480,$14)
	SCCBWriteRegister($5481,$21)
	SCCBWriteRegister($5482,$36)
	SCCBWriteRegister($5483,$57)
	SCCBWriteRegister($5484,$65)
	SCCBWriteRegister($5485,$71)
	SCCBWriteRegister($5486,$7d)
	SCCBWriteRegister($5487,$87)
	SCCBWriteRegister($5488,$91)
	SCCBWriteRegister($5489,$9a)
	SCCBWriteRegister($548a,$aa)
	SCCBWriteRegister($548b,$b8)
	SCCBWriteRegister($548c,$cd)
	SCCBWriteRegister($548d,$dd)
	SCCBWriteRegister($548e,$ea)
	SCCBWriteRegister($548f,$10)
	SCCBWriteRegister($5490,$05)
	SCCBWriteRegister($5491,$00)
	SCCBWriteRegister($5492,$04)
	SCCBWriteRegister($5493,$20)
	SCCBWriteRegister($5494,$03)
	SCCBWriteRegister($5495,$60)
	SCCBWriteRegister($5496,$02)
	SCCBWriteRegister($5497,$b8)
	SCCBWriteRegister($5498,$02)
	SCCBWriteRegister($5499,$86)
	SCCBWriteRegister($549a,$02)
	SCCBWriteRegister($549b,$5b)
	SCCBWriteRegister($549c,$02)
	SCCBWriteRegister($549d,$3b)
	SCCBWriteRegister($549e,$02)
	SCCBWriteRegister($549f,$1c)
	SCCBWriteRegister($54a0,$02)
	SCCBWriteRegister($54a1,$04)
	SCCBWriteRegister($54a2,$01)
	SCCBWriteRegister($54a3,$ed)
	SCCBWriteRegister($54a4,$01)
	SCCBWriteRegister($54a5,$c5)
	SCCBWriteRegister($54a6,$01)
	SCCBWriteRegister($54a7,$a5)
	SCCBWriteRegister($54a8,$01)
	SCCBWriteRegister($54a9,$6c)
	SCCBWriteRegister($54aa,$01)
	SCCBWriteRegister($54ab,$41)
	SCCBWriteRegister($54ac,$01)
	SCCBWriteRegister($54ad,$20)
	SCCBWriteRegister($54ae,$00)
	SCCBWriteRegister($54af,$16)
	SCCBWriteRegister($3406,$00)
	SCCBWriteRegister($5192,$04)
	SCCBWriteRegister($5191,$f8)
	SCCBWriteRegister($5193,$70)
	SCCBWriteRegister($5194,$f0)
	SCCBWriteRegister($5195,$f0)
	SCCBWriteRegister($518d,$3d)
	SCCBWriteRegister($518f,$54)
	SCCBWriteRegister($518e,$3d)
	SCCBWriteRegister($5190,$54)
	SCCBWriteRegister($518b,$c0)
	SCCBWriteRegister($518c,$bd)
	SCCBWriteRegister($5187,$18)
	SCCBWriteRegister($5188,$18)
	SCCBWriteRegister($5189,$6e)
	SCCBWriteRegister($518a,$68)
	SCCBWriteRegister($5186,$1c)
	SCCBWriteRegister($5181,$50)
	SCCBWriteRegister($5184,$25)
	SCCBWriteRegister($5182,$11)
	SCCBWriteRegister($5183,$14)
	SCCBWriteRegister($5184,$25)
	SCCBWriteRegister($5185,$24)
	SCCBWriteRegister($5025,$82)
	SCCBWriteRegister($3a0f,$7e)
	SCCBWriteRegister($3a10,$72)
	SCCBWriteRegister($3a1b,$80)
	SCCBWriteRegister($3a1e,$70)
	SCCBWriteRegister($3a11,$d0)
	SCCBWriteRegister($3a1f,$40)
	SCCBWriteRegister($5583,$40)
	SCCBWriteRegister($5584,$40)
	SCCBWriteRegister($5580,$02)
	SCCBWriteRegister($3633,$07)
	SCCBWriteRegister($3702,$10)
	SCCBWriteRegister($3703,$b2)
	SCCBWriteRegister($3704,$18)
	SCCBWriteRegister($370b,$40)
	SCCBWriteRegister($370d,$02)
	SCCBWriteRegister($3620,$52)
	SCCBWriteRegister($3808,$01)

	SCCBWriteRegister($3809,$40)
	SCCBWriteRegister($380a,$00)

	SCCBWriteRegister($380b,$f0)

	SCCBWriteRegister($3a00,$78)


	SCCBWriteRegister($3818,$A1)
	SCCBWriteRegister($3621,$E7)

	SCCBWriteRegister($4740,$21)

	SCCBWriteRegister($5001,$ff)
	SCCBWriteRegister($5580,$04)
	SCCBWriteRegister($5587,$24)
	SCCBWriteRegister($5588,$24)
	SCCBWriteRegister($558a,$00)

	SCCBWriteRegister($5001,$ff)
	SCCBWriteRegister($5583,$40)
	SCCBWriteRegister($5584,$40)
	SCCBWriteRegister($5580,$02)

	SCCBWriteRegister($5001,$ff)
	SCCBWriteRegister($5589,$10)
	SCCBWriteRegister($5580,$04)
	SCCBWriteRegister($558a,$00)

	SCCBWriteRegister($3406,$0 )
	SCCBWriteRegister($5192,$04)
	SCCBWriteRegister($5191,$f8)
	SCCBWriteRegister($518d,$26)
	SCCBWriteRegister($518f,$42)
	SCCBWriteRegister($518e,$2b)
	SCCBWriteRegister($5190,$42)
	SCCBWriteRegister($518b,$d0)
	SCCBWriteRegister($518c,$bd)
	SCCBWriteRegister($5187,$18)
	SCCBWriteRegister($5188,$18)
	SCCBWriteRegister($5189,$56)
	SCCBWriteRegister($518a,$5c)
	SCCBWriteRegister($5186,$1c)
	SCCBWriteRegister($5181,$50)
	SCCBWriteRegister($5184,$20)
	SCCBWriteRegister($5182,$11)
	SCCBWriteRegister($5183,$0 )

	SCCBWriteRegister($3a0f,$58)
	SCCBWriteRegister($3a10,$50)
	SCCBWriteRegister($3a11,$91)
	SCCBWriteRegister($3a1b,$58)
	SCCBWriteRegister($3a1e,$50)
	SCCBWriteRegister($3a1f,$20)

	SCCBWriteRegister($5580,$01)
	SCCBWriteRegister($5581,$6f)
	SCCBWriteRegister($5582,$20)
	SCCBWriteRegister($558a,$01)

	SCCBWriteRegister($501e,$2a)
	SCCBWriteRegister($5002,$f8)
	SCCBWriteRegister($501f,$01)
	SCCBWriteRegister($4300,$61)

	SCCBWriteRegister($3808,$01)
	SCCBWriteRegister($3809,$40)
	SCCBWriteRegister($380a,$00)
	SCCBWriteRegister($380b,$f0)

	SCCBWriteRegister($ffff,$ff)
Pub doSVGApreview
    SCCBWriteRegister($3800 ,$1 )
		SCCBWriteRegister($3801 ,$50)
		SCCBWriteRegister($3802 ,$0 )
		SCCBWriteRegister($3803 ,$8 )
		SCCBWriteRegister($3804 ,$5 )
		SCCBWriteRegister($3805 ,$0 )
		SCCBWriteRegister($3806 ,$3 )
		SCCBWriteRegister($3807 ,$c0)
		SCCBWriteRegister($3808 ,$3 )
		SCCBWriteRegister($3809 ,$20)
		SCCBWriteRegister($380a ,$2 )
		SCCBWriteRegister($380b ,$58)
		SCCBWriteRegister($380c ,$c )
		SCCBWriteRegister($380d ,$80)
		SCCBWriteRegister($380e ,$3 )
		SCCBWriteRegister($380f ,$e8)
		SCCBWriteRegister($5001 ,$7f)
		SCCBWriteRegister($5680 ,$0 )
		SCCBWriteRegister($5681 ,$0 )
		SCCBWriteRegister($5682 ,$5 )
		SCCBWriteRegister($5683 ,$0 )
		SCCBWriteRegister($5684 ,$0 )
		SCCBWriteRegister($5685 ,$0 )
		SCCBWriteRegister($5686 ,$3 )
		SCCBWriteRegister($5687 ,$c0)
		SCCBWriteRegister($5687 ,$c0)
		SCCBWriteRegister($3815 ,$02)

	'	 ////RGB565
	'	//SCCBWriteRegister($501e ,$2a)//
	'	//SCCBWriteRegister($5002 ,$f8) ///////
	'	//SCCBWriteRegister($501f ,$01)
	'	//SCCBWriteRegister($4300 ,$61)//, ///////////////

		SCCBWriteRegister($4740, $0021)  'VSYNC Positive
		SCCBWriteRegister($3818, $A1)	'	//VFLIP

		SCCBWriteRegister($ffff, $ff)
Pub doVGApreview
        SCCBWriteRegister($3011 ,$08)
        SCCBWriteRegister($3012 ,$00)
        SCCBWriteRegister($3010 ,$10)
        SCCBWriteRegister($460c ,$22)
        SCCBWriteRegister($380c ,$0c)
        SCCBWriteRegister($380d ,$80)
        SCCBWriteRegister($3a00 ,$7c)
        SCCBWriteRegister($3a08 ,$09)
        SCCBWriteRegister($3a09 ,$60)
        SCCBWriteRegister($3a0a ,$07)
        SCCBWriteRegister($3a0b ,$d0)
        SCCBWriteRegister($3a0d ,$08)
        SCCBWriteRegister($3a0e ,$06)
Pub doFREX
        SCCBWriteRegister($3017 ,$7f)
        SCCBWriteRegister($3079 ,$10)
        SCCBWriteRegister($471d ,$02)
        SCCBWriteRegister($302c ,$00)

Pub doNightMode
  SCCBWriteRegister($3011 ,$08)
  SCCBWriteRegister($3012 ,$00)
  SCCBWriteRegister($3010 ,$70)
  SCCBWriteRegister($460c ,$22)
  SCCBWriteRegister($380c ,$0c)
  SCCBWriteRegister($380d ,$80)
  SCCBWriteRegister($3a00 ,$78)
  SCCBWriteRegister($3a08 ,$09)
  SCCBWriteRegister($3a09 ,$60)
  SCCBWriteRegister($3a0a ,$07)
  SCCBWriteRegister($3a0b ,$d0)
  SCCBWriteRegister($3a0d ,$08)
  SCCBWriteRegister($3a0e ,$06)
Pri DefineSignal
  GetID
  
  ser.str(string(13,"Please wait... gathering signal characteristics"))
  ctrb := %01010<< 26  + _CAM_PCLK_PIN  
  sig:=ctrb        ' Counter B: POSEDGE 
 ' ser.dec(sig)
  frqb := 1
  ser.str(string(13,"Pixel Clock Freq (spin)= "))
  pixelclocks:=GetSigAv(3)
  ser.dec(pixelclocks)
  start:=2
  repeat until start==0
  ser.str(string("  (pasm)="))
  ser.dec(sig)
  ser.tx(13)
  if (pixelclocks<=100000)
     ser.str(string("Sorry No Signal"))
     ser.str(string(13,"set XCLK to 24000000 and repeat.",13))
     if Camera_ID==0
       ser.str(string("We are unable to get camera identification and there is no signal"))
       ser.str(string(13,"Check the documentation to see if identification of this camera is supported by this software version"))
     if Camera_ID>0
       ser.str(string(13,"DON'T PANIC: your camera has been identified but signal analysis has failed... this is normal"))
       ser.str(string(13,"Some Cameras produce no signal with factory default settings"))
       ser.str(string(13,"Only the OV5642 is supported with non-factory default settings."))
       waitcnt(clkfreq*5+cnt)
     if Camera_ID==$7673
       ser.str(string(13, "Your camera is from the OV76xx family.  At 24MHz, it should produce stable signals."))  
      
       waitcnt(clkfreq*5+cnt)
     waitcnt(clkfreq*5+cnt)
     return
  ctrb := %01010<< 26  + _CAM_VSYNC_PIN
  framerate:=GetSigAv(3)
  if framerate ==0
    ser.str(String(13,"No Vsync detected"))
    waitcnt(clkfreq + cnt)
    return
           ' Counter B: POSEDGE on vsync
  ser.str(string("Frame Rate Analysis "))
  cps:=clkfreq
  repeat reps
    sig:= %01010<< 26  + _CAM_VSYNC_PIN 
    start:=3
    repeat until start==0
    ser.str(string(13,"p1 clocks in frame(p1cpf)="))
    ser.dec(sig)
    ser.str(string("    Calculated fps(clkfreq/p1cpf=)"))
    framerate:=clkfreq/sig
    ser.dec(framerate)
    ser.str(string("."))
    framerate:=((cps//sig)*10)/sig
    ser.dec(framerate)         ' Counter B: POSEDGEs
  repeat reps
    pinstate:=1<< _CAM_VSYNC_PIN  
    ctrb := %01010<< 26  + _CAM_HREF_PIN 
    frqb:=1
    waitpeq (pinstate,pinstate,0) 'wait til vsync hi
                                  
    waitpne(pinstate,pinstate,0)   'wait til vsync low
    phsb := 0                      'start measuring positive edges on HREF
    waitpeq (pinstate,pinstate,0)  'measure until vsync high
    linesperframe:=phsb                                         ' 
    ser.str(string(13,"Spin Lines Per Frame = "))
    ser.dec(linesperframe)
    sig:=%01010<< 26  + _CAM_HREF_PIN
    phsb:=0
    start:=5
    repeat until start == 0
    ser.str(string("  PASM Lines Per Frame="))
    ser.dec(sig)
  pinstate:=1<<_CAM_HREF_PIN   
  ctrb := %01010<< 26  + _CAM_PCLK_PIN
  sig:=ctrb
  repeat reps
    sig:=ctrb
    start:=4
    repeat until start == 0
    
    ser.str(string(13,"Pasm_PixClks_Per_line_valid (href hi only) ="))
    ser.dec(sig)
    ser.str(string(" +/- 3"))
  repeat 1
    waitpeq(pinstate,pinstate,0)
    waitpne(pinstate,pinstate,0)
    waitpeq(pinstate,pinstate,0)
    phsb:=0
    waitpne(pinstate,pinstate,0)
    waitpeq(pinstate,pinstate,0)
    pixelsperline:=phsb
    ser.str(string(13,"Spin_PixClks_PerLine(href hi + low)= "))
    'PixelsperLine:= pixelclocks/(framerate*linesperframe)
    ser.dec(pixelsperline)
    ser.str(string(" +/- ?"))
  GetHREF
  GetVSync
  waitcnt(clkfreq*2 + cnt)                                         ' Clear Serial Terminal Screen
  ser.str(string(13,"    DONE"))
  Time := cnt                                           ' Current cnt Value


Pub transmit | a
  i:=0
  a:=127
  repeat nlines 'lines
    repeat ppl 'pixels
      ser.dec(databuffer[i])

     ' ser.dec(a)
      ser.tx(32)
      i++
    ser.tx(13)



DAT
                        org     0
entry
mainloop                rdlong   _cmd,par  'wait for command to start... anything other than zero
                        cmp   _cmd,#0  wz
              if_e      jmp #mainloop
                        cmp _cmd,#1 wz
              if_e      jmp #Start_Capture
                        cmp _cmd,#2 wz
              if_e      jmp #Get_PixelClock
                        cmp _cmd,#3 wz
              if_e      jmp #Get_FramePeriod
                        cmp _cmd,#4 wz
              if_e      jmp #Get_pixClocksPerHref
                        cmp _cmd,#5 wz
              if_e      jmp #Get_LinesPerFrame
                        jmp #mainloop
             
Get_LinesPerFrame      
                        mov ptraddr,par
                        sub ptraddr,#4
                        rdlong ctrbmode,ptraddr
                        mov ctrb,ctrbmode
                        mov frqb,#1
                        call #wait_vsync_h
                        call #wait_vsync_l
                        mov phsb,zero
                        call #wait_vsync_h
                        mov temp1,phsb
                        
                        wrlong temp1,ptraddr
                        add ptraddr,#4 
                        wrlong zero,ptraddr   
                        jmp #mainloop          
Get_pixClocksPerHref              
                        mov ptraddr,par
                        sub ptraddr,#4
                        rdlong ctrbmode,ptraddr
                        mov ctrb,ctrbmode
                        mov frqb,#1
                        call #wait_href_l
                        call #wait_href_h
                        mov phsb,zero
                        call #wait_href_l
                        mov temp1,phsb
                        
                        wrlong temp1,ptraddr
                        add ptraddr,#4 
                        wrlong zero,ptraddr   
                        jmp #mainloop
                        
Get_FramePeriod         mov ptraddr,par
               
                        call    #wait_vsync_h                         
                        call    #wait_vsync_l
                        mov     timer1,cnt
                        call    #wait_vsync_h
                        call    #wait_vsync_l
                        mov     timer2,cnt
                        sub     timer2,timer1
                        sub     ptraddr,#4
                        wrlong  timer2,ptraddr

  
                        add ptraddr,#4 
                        wrlong zero,ptraddr   
                        jmp #mainloop
Get_PixelClock                

                        mov ptraddr,par
                        mov frqb,#1
                        sub ptraddr,#4
                        rdlong ctrbmode,ptraddr
                        mov ctrb,ctrbmode
                        mov timer1,delay
                        add timer1,cnt
                        mov phsb,#0
                        waitcnt timer1,#0
                        mov temp1,phsb
                        
                        wrlong temp1,ptraddr
                        add ptraddr,#4
                        wrlong zero,ptraddr
                        
                        
                        
                        
                        
                        
                        jmp #mainloop
                        
Start_Capture
                        mov   ptraddr,par
                        wrlong zero,ptraddr
                        add   ptraddr,#4
                        mov   linecnt,nlines
                        mov   pixelcnt,ppl

                        call  #wait_vsync_h   'waits for vsync high
                        call  #wait_vsync_l   'waits for vsync to go low
                        mov   temp2,windowy

skiplines               call  #wait_href_h'wait until href is high  'skip every other line...
                        call #wait_href_l
                        djnz  temp2,#skiplines


getframe                
                        mov   pixelcnt,ppl

                        call  #wait_href_h'wait until href is high  'skip every other line...
                        call #wait_href_l                           '...skip every other line
                  '      djnz  temp2,#skiplines
                        call  #wait_href_h'wait until href is high

getline                 call  #wait_PCLK_l 'wait until pixelclock is low

                        mov   temp,ina

                        wrbyte temp,ptraddr
                        call  #wait_PCLK_h
                        add ptraddr, #1

                        call #wait_PCLK_l 'wait until pixelclock is low
                     '   mov   temp,ina

                     '   wrbyte temp,ptraddr
                        call  #wait_PCLK_h
                     '   add ptraddr, #1
                        djnz pixelcnt,#getline
                        call #wait_href_l
                        djnz linecnt,#getframe



                        jmp #mainloop


wait_vsync_h            mov     regA, ina               ' Get value of port A                   wait vsync high        4 [4]
                        and     regA, CamVSYNC    wz   ' Look at VSYNC pin only                        4 [8]
              if_z      jmp     #wait_vsync_h

wait_vsync_h_ret        ret

wait_vsync_l            mov     regA, ina               ' Get value of port A                         wait vsynch low
                        and     regA, CamVSYNC    wz
              if_nz     jmp     #wait_vsync_l

wait_vsync_l_ret        ret

wait_href_h             mov     regA, ina               ' Get value of port A                   wait vsync high        4 [4]
                        and     regA, CamHRef    wz   ' Look at Href pin only                        4 [8]
              if_z      jmp     #wait_href_h

wait_href_h_ret        ret

wait_href_l             mov     regA, ina               ' Get value of port A                   wait vsync high        4 [4]
                        and     regA, CamHRef    wz   ' Look at Href pin only                        4 [8]
              if_nz      jmp     #wait_href_l

wait_href_l_ret        ret

wait_PCLK_h            mov regA,ina
                       and regA, PCLK wz
              if_z     jmp #wait_PCLK_h
wait_PCLK_h_ret        ret

wait_PCLK_l              mov regA,ina
                        and regA, PCLK wz
              if_nz     jmp #wait_PCLK_l
wait_PCLK_l_ret         ret
                           '






'constant
CamVSYNC               long    1<< _CAM_VSYNC_PIN    
CamHRef                long    1<< _CAM_HREF_PIN       
PCLK                   long    1<< _CAM_PCLK_PIN   
'

mycon                  long 565
ppl                    long  48
nlines                 long 500
testlong               long  %00001000_00000000_00000100_11111111
zero                   long 0
windowy                long 200

delay         long _clkfreq
'var

regA          res 1
temp1         res 1
temp2         res 1
timer1        res 1
timer2
temp          res 1
VsyncHaddr    res 1
VsyncLaddr    res 1
ptraddr       res 1
linecnt       res 1
pixelcnt      res 1
_cmd           res 1
ctrbmode      res 1

